Loading...
Searching...
No Matches
etl::priority_queue< T, SIZE, TContainer, TCompare > Class Template Reference

`#include <priority_queue.h>`

## Public Types

typedef TContainer::size_type | size_type
typedef TContainer | container_type
Public Types inherited from etl::ipriority_queue< T, TContainerBase, TCompare >
typedef T | value_type
| The type stored in the queue.
typedef TCompare | compare_type
| The comparison type.
typedef TContainerBase | container_base_type
| The non-sized container base type.
typedef T & | reference
| A reference to the type used in the queue.
typedef const T & | const_reference
| A const reference to the type used in the queue.
typedef TContainerBase::size_type | size_type
| The type used for determining the size of the queue.
typedef TContainerBase::difference_type | difference_type

## Public Member Functions

| priority_queue ()
| Default constructor.
| priority_queue (const priority_queue &rhs)
| Copy constructor.
template<typename TIterator>
| priority_queue (TIterator first, TIterator last)
| ~priority_queue ()
| Destructor.
priority_queue & | operator= (const priority_queue &rhs)
| Assignment operator.
Public Member Functions inherited from etl::ipriority_queue< T, TContainerBase, TCompare >
reference | top ()
const_reference | top () const
void | push (const_reference value)
void | emplace ()
template<typename T1>
void | emplace (const T1 &value1)
template<typename T1, typename T2>
void | emplace (const T1 &value1, const T2 &value2)
template<typename T1, typename T2, typename T3>
void | emplace (const T1 &value1, const T2 &value2, const T3 &value3)
template<typename T1, typename T2, typename T3, typename T4>
void | emplace (const T1 &value1, const T2 &value2, const T3 &value3, const T4 &value4)
template<typename TIterator>
void | assign (TIterator first, TIterator last)
void | pop ()
void | pop_into (reference destination)
size_type | size () const
| Returns the current number of items in the priority queue.
size_type | max_size () const
| Returns the maximum number of items that can be queued.
bool | empty () const
bool | full () const
size_type | available () const
void | clear ()
| Clears the queue to the empty state.
ipriority_queue & | operator= (const ipriority_queue &rhs)
| Assignment operator.

## Static Public Attributes

static ETL_CONSTANT size_type | MAX_SIZE = size_type(SIZE)

## Additional Inherited Members

Protected Member Functions inherited from etl::ipriority_queue< T, TContainerBase, TCompare >
| ~ipriority_queue ()
| Destructor.
| ipriority_queue (TContainerBase &container_)
| The constructor that is called from derived classes.

## Detailed Description

template<typename T, const size_t SIZE, typename TContainer = etl::vector<T, SIZE>, typename TCompare = etl::less<typename TContainer::value_type>>
class etl::priority_queue< T, SIZE, TContainer, TCompare >

A fixed capacity priority queue. This queue does not support concurrent access by different threads.

Template Parameters

  T | The type this queue should support.
  SIZE | The maximum capacity of the queue.

## Constructor & Destructor Documentation

## priority_queue()

template<typename T, const size_t SIZE, typename TContainer = etl::vector<T, SIZE>, typename TCompare = etl::less<typename TContainer::value_type>>
template<typename TIterator>

etl::priority_queue< T, SIZE, TContainer, TCompare >::priority_queue | ( | TIterator | first,
|  | TIterator | last )

inline

Constructor, from an iterator range.

Template Parameters

  TIterator | The iterator type.

Parameters

  first | The iterator to the first element.
  last | The iterator to the last element + 1.

The documentation for this class was generated from the following file:

- include/etl/priority_queue.h